/*************************************************************************
** Wolf3D Legacy
** Copyright (C) 2012 by LinuxWolf - Team RayCAST
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**************************************************************************
** LinuxWolf Library for Wolf3D Legacy
*************************************************************************/

#ifndef LWLIB_COLORREMAP_H
#define LWLIB_COLORREMAP_H

#include "lw_misc.h"
#include "lw_vec.h"

namespace lwlib
{
	namespace ColorRemap_Color
	{
		enum e
		{
			Green,
			Default = Green,
			Grey,
			Red,
			Yellow,
			LightBlue,
			DarkBlue,
			Violet,
			Brown,
			Last = Brown,
		};
	}

	typedef lwlib_Byte_t ColorRemap_Table_t[256];

	class ColorRemap
	{
		struct
		{
			ColorRemap_Table_t tables[ColorRemap_Color::Last + 1];
			lwlib_Byte_t *activeTable;
		} priv;

		void initTables();

	public:
		ColorRemap();

		void setActiveColor(ColorRemap_Color::e color);

		lwlib_Byte_t *getActiveTable();
	};

	lwlib_Byte_t ColorRemap_GetStart(ColorRemap_Color::e color);

	Point4b ColorRemap_GetColorRgba(ColorRemap_Color::e color);
}

#endif
