/*************************************************************************
** Wolf3D Legacy
** Copyright (C) 2012 by LinuxWolf - Team RayCAST
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**************************************************************************
** LinuxWolf Library for Wolf3D Legacy
*************************************************************************/

#include "lw_modelmaker.h"
#include "lw_intmap.h"
#include "lw_csg.h"
using namespace lwlib;

void ModelMaker::drawModel(Gl *gl)
{
#if 0
	if (m_wireframeMode)
	{
		lwlib_Gl_SetWireframeMode(gl, true);
	}

	if (!m_wireframeMode)
	{
		lwlib_Gl_EnableLighting(gl, cameraPos);
	}

	lwmm_Model_Render(m_model, gl, m_camera);
	lwmm_CellMarker_Render(m_cellMarker, gl, m_camera);

	if (!m_wireframeMode)
	{
		lwlib_Gl_DisableLighting(gl);
	}

	if (m_wireframeMode)
	{
		lwlib_Gl_SetWireframeMode(gl, false);
	}
#endif
}

ModelMaker::ModelMaker()
{
	lwlib_Zero(priv);
#if 0
	m_camera = lwlib_Camera_New();
	m_cellMarker = lwmm_CellMarker_New();
#endif
}

ModelMaker::~ModelMaker()
{
}

void ModelMaker::draw(Gl *gl)
{
	drawModel(gl);
#if 0
	if (lwmm_Model_Valid(m_model))
	{
		const lwlib_TPoint3f cameraPos = 
			lwlib_Camera_GetPosition(m_camera);
		const lwlib_TPoint3f cameraAngles = 
			lwlib_Camera_GetAngles(m_camera);
		lwlib_Gl_PushMatrix(gl);
		lwlig_Gl_CameraTransformMatrix(gl, cameraPos, cameraAngles);
		lwlib_ModelMaker_DrawModel(modelMaker, gl);
		lwlib_Gl_PopMatrix(gl);
	}
#endif
}

void ModelMaker::addToEdit(Edit *edit)
{

#if 0
	lwlib_Edit_AddGroup(edit, "cellMarker", 
		lwlib_ModelMaker_CellMarkerAddToEdit(modelMaker, edit));
#endif
}

void ModelMaker::updateEdit(Edit *edit)
{

#if 0
	lwlib_Edit_AddGroup(edit, "cellMarker", 
		lwlib_ModelMaker_CellMarkerAddToEdit(modelMaker, edit));
#endif
}

void ModelMaker::updateFrame()
{
}
