/*************************************************************************
** Wolf3D Legacy
** Copyright (C) 2012 by LinuxWolf - Team RayCAST
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**************************************************************************
** LinuxWolf Library for Wolf3D Legacy
*************************************************************************/

#ifndef LWLIB_PICVIEWER_H
#define LWLIB_PICVIEWER_H

#include "lw_img.h"
#include "lw_font.h"
#include "lw_keys.h"
#include "lw_edit.h"
#include "lw_tool.h"

namespace lwlib
{
	class PicViewer : public Tool
	{
		struct
		{
			lwlib_Keys_t keys;
			Gl *gl;
			Font *font;
			SDL_Color *palette;
			Edit *edit;
			int picSelector;
			int oldPicSelector;
			Img_t picImg;
		} priv;

		void drawPic(int pic, int cx, int cy, int sw, int sh);

	public:
		PicViewer();

		virtual ~PicViewer();

		virtual void addToEdit(Edit *edit);

		virtual void updateEdit(Edit *edit);

		virtual void updateFrame();

		virtual void draw(Gl *gl);

		Img_t getPicImg(int pic);

		void setGl(Gl *gl);

		void setKeys(lwlib_Keys_t keys);

		void setFont(Font *font);

		void setPalette(SDL_Color *palette);

		void setEdit(Edit *edit);
	};
}

#endif
