/*************************************************************************
** Wolf3D Legacy
** Copyright (C) 2012 by LinuxWolf - Team RayCAST
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**************************************************************************
** LinuxWolf Library for Wolf3D Legacy
*************************************************************************/

#ifndef LWLIB_TOOL_H
#define LWLIB_TOOL_H

#include "lw_edit.h"
#include "lw_gl.h"
#include "vec.h"

namespace lwlib
{
	class Tool
	{
	public:
		virtual ~Tool()
		{
		}

		virtual void draw(Gl *gl) = 0;
		virtual void addToEdit(Edit *edit) = 0;
		virtual void updateEdit(Edit *edit) = 0;
		virtual void updateFrame() = 0;
	};

	typedef Tool *ToolPtr_t;

	typedef vec_t(ToolPtr_t) ToolPtrSeq_t;
}

#endif
